package web.cps

import ant.cps.Card
import web.base.data.{ProposedChangeFrag, ProposedChangesFrag}
import japgolly.scalajs.react._
import vdom.html_<^._
import web.cps.AnnotatedRow.Baton

object HomeChangeList {

  case class Props(changes: Seq[ProposedChangeFrag], b: Baton)

  val C = ScalaComponent
    .builder[Props]("HomeChangeList")
    .stateless
    .render { rs =>
      val body = if (rs.props.changes.isEmpty) {
        <.span(<.strong("No Changes"), " pending, have a great day.")
      } else {
        val num = rs.props.changes.size
        <.span(<.strong(s"$num Changes"), " waiting for approval.  Don't worry, we have not forgotten.")
      }
      Card(new Card.Opts {
        override val extra     = rs.props.b.button.rawElement
        override val className = "card-thck"
      })(<.span("You have ", body))
    }
    .build
}
