package web.cps.a1quote

import ant.cps._
import ant.cps.Form.{FormFacade, FormProps, Item}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import rmi.ReactMaskedInput
import shared.models.a1.FieldKey._
import shared.models.a1.{DataCache, FieldKey}
import web.cps.{style, DiscreteNumericInput, FormMaskedInput, IntSwitch}

object SpecialItemsControl {
  case class Props(form: FormProps)

  class Backend(val $ : BackendScope[Props, Unit]) extends FormFacade {
    @inline def form = $.props.runNow().form

    def formIn[T1](label: String,
                   name: FieldKey[T1],
                   discrete: Vector[Int],
                   inputOps: ReactMaskedInput.Opts = new ReactMaskedInput.Opts {}) = {
      Item(style.respItem(label))(
        getFieldDecorator(name.value)(DiscreteNumericInput.C(
          DiscreteNumericInput.Props(form, name.value, discrete, fmt = DiscreteNumericInput.formatUSD))))
    }

    def render(p: Props) = {
      <.div(
        formIn("Jewelry, Watches and Furs", JewelrySL, DataCache.jewelry),
        formIn("Money", MoneySL, DataCache.money),
        formIn("Securities", SecuritiesSL, DataCache.securities),
        formIn("Silverware, Goldware and Pewter", SilverwareSL, DataCache.silverware),
        formIn("Firearms", FirearmsSL, DataCache.firearms),
        formIn("Electronic Apparatus's", ElectronicApparatusSL, DataCache.electronics),
        Item(style.respItem("Tapes, Records"))(
          getFieldDecorator(TapesRecordsSL.value)(
            Radio.Group()(Radio.Button(value = 250)("$250"), Radio.Button(value = 500)("$500")))),
        formIn("Laptop and Computers", PootersSL, DataCache.laptop),
      )
    }
  }
  val C = ScalaComponent.builder[Props]("SpecialItems").stateless.renderBackend[Backend].build
}
