package web.cps.a1quote

import ant.cps.Form.{FormFacade, FormProps, Item}
import ant.cps.FormCreate.TypedFieldOptions
import ant.cps._
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import rmi.ReactMaskedInput
import shared.models.a1.FieldKey._
import shared.models.a1.{DataCache, FieldKey}
import web.cps.a1quote.Step1.style
import web.cps.{DiscreteNumInput, DiscreteNumericInput}

import scala.scalajs.js

object SpecialItemsCtl {
  case class Props(form: FormProps)

  def fullItem(s: String): Item.Opt = new Item.Opt {
    override val label    = s
    override val required = false
  }

  class Backend(val $ : BackendScope[Props, Unit]) extends FormFacade {
    @inline def form = $.props.runNow().form

    def formIn[T1](label: String,
                   name: FieldKey[T1],
                   discrete: Vector[Int],
                   inputOps: ReactMaskedInput.Opts = new ReactMaskedInput.Opts {}) = {
      Item(fullItem(label))(
        getFieldDecorator(name)(
          DiscreteNumInput.C(DiscreteNumInput.Props(form, name.value, discrete, fmt = DiscreteNumericInput.formatUSD))))
    }

    def render(p: Props) = {
      <.div(
        FormCtl.ttrow()(<.div("Left"))(
          //          s =>
          //            Item(fullItem("Tapes, Records"))(
          //              getFieldDecorator(TapesRecordsSL.value)(
          //                Radio.Group()(Radio.Button(value = 250)("$250"), Radio.Button(value = 500)("$500"))
          //              )
          //          ),
          s => formIn("Laptop and Computers", PootersSL, DataCache.laptop)),
        FormCtl.splitTTRow()(<.div("Left"), <.div("Right"))(
          s => formIn("Jewelry, Watches and Furs", JewelrySL, DataCache.jewelry),
          s => formIn("Money", MoneySL, DataCache.money),
        ),
        FormCtl.splitTTRow()(<.div("Left"), <.div("Right"))(
          s => formIn("Securities", SecuritiesSL, DataCache.securities),
          s => formIn("Silverware, Goldware and Pewter", SilverwareSL, DataCache.silverware),
        ),
        FormCtl.splitTTRow()(<.div("Left"), <.div("Right"))(
          s => formIn("Firearms", FirearmsSL, DataCache.firearms),
          s => formIn("Electronic Apparatus's", ElectronicApparatusSL, DataCache.electronics),
        ))
    }
  }
  val C = ScalaComponent.builder[Props]("SpecialItems").stateless.renderBackend[Backend].build
}
