package web.mutation

import dispalt.relay.gql
import relay.raw.Relay
import relay.runtime.mutation.{CommitMutation, MutationConfig, MutationInput}
import relay.runtime.store.RelayEnvironment
import web.base.data.LocalRelayError
import web.base.all._

import scala.scalajs.js

object LoginMutation {

  @gql("""
    mutation LoginMutation(
      $input: LoginInput!
    ){
      login(input: $input) {
        clientMutationId
        viewer {
          id
          user {
            user {
              id
            }
            permissions
            roles
          }
        }
      }
    }
  """)
  object mut extends js.Object

  def commit(env: RelayEnvironment, v: js.Object) = {
    CommitMutation[js.Object, js.Object](env, relay.generated.LoginMutation, v).map(_.left.map(LocalRelayError(_)))
  }

}
