package web.mutation

import ant.cps.FormCreate.TypedFieldOptions
import dispalt.relay.gql
import monix.eval.Task
import org.scalajs.dom
import relay.generated.QuoteA1Builder
import relay.graphql.TaggedNode
import relay.runtime.RecordSourceSelectorProxy
import relay.runtime.RelayRuntime.{ConnectionHandler, ViewerHandler}
import relay.runtime.mutation.CommitMutation
import relay.runtime.store.RelayEnvironment
import shared.proto.TaggedClass
import shared.proto.TaggedClassSerDe._
import shared.proto.base.RawField
import web.base.all._
import web.base.data.{KeyedRateFailure, LocalRateChecked}
import web.cps.a1quote.QuoteA1Frag

import scala.scalajs.js.JSConverters._
import scala.scalajs.js
import scala.scalajs.js.Dynamic.literal
import scala.scalajs.js.{|, UndefOr}

object QuoteA1BuilderM {

  trait ResultQa1 extends js.Object {
    val resp: LocalRateChecked with QuoteA1Frag
  }
  @js.native
  trait Result extends js.Object {
    val qa1build: ResultQa1
  }

  @gql("""
    mutation QuoteA1Builder($input: QuoteA1BuilderInput!) {
      qa1build(input: $input) {
        clientMutationId
        resp {
          l { key msg }
          ...QuoteParent_qa1
        }
      }
    }
  """)
  object mut extends TaggedNode

  def commit[M: TaggedClass](env: RelayEnvironment, msg: M, tfo: js.UndefOr[TypedFieldOptions[js.Any]] = js.undefined)
    : Task[Vector[KeyedRateFailure] Either QuoteA1Frag | Null] = {
    CommitMutation[PBufInput, Result](env,
                                      QuoteA1Builder.query,
                                      PBufInput(msg),
                                      update = None,
                                      optimisticResponse = tfo.map { tfo =>
                                        val res = literal(qa1build = literal(resp = literal()))
                                        res.qa1build.resp.updateDynamic(tfo.name.get)(tfo.value)
                                        res
                                      }) map {
      case Left(e) =>
        Left(Vector(KeyedRateFailure("", e.map(_.message))))
      case Right(result) =>
        val resp = result.qa1build.resp
        var res  = Vector.empty[KeyedRateFailure]
        if (!js.isUndefined(resp.l) && resp.l.length > 0) {
          val r = resp.l.groupBy(f => f.key)
          /* && is used because they either have to all be warnings or one error makes it false */
          res = res ++ r.values
            .map(f => KeyedRateFailure(f(0).key, f.map(_.msg)))
            .toVector
        }

        if (res.isEmpty) {
          Right(resp)
        } else {
          Left(res)
        }
    }
  }
}
