package web.views

import ant.cps.{Col, Menu, Row}
import dispalt.relay.gql
import japgolly.scalajs.react._
import japgolly.scalajs.react.extra.router.RouterCtl
import org.scalajs.dom
import relay.components.FragmentContainer
import vdom.html_<^._
import web.base.data.BaseViewerFrag
import web.base.all._
import web.routes.Routes
import web.routes.Routes.Page
import relay.components._
import relay.generated.Home_viewer
import web.cps.{AnnotatedRow, HomeChangeList, PolicyList}
import web.react.RelayBackend

import scala.scalajs.js

object Home {

  @gql("""
        fragment Home_viewer on Viewer {
          user {
            user {
              firstName
           }
          }

          policies(after: $after, first: $first) {
            edges {
              node {
                quoteId
                policyId
                userId
                email
                activatedMs
                contractValue
                details {
                  details {
                    namedInsured { firstName lastName }
                  }
                  sec1 { coverageC coverageD deductible }
                  sec2 { coverageE coverageF }
                }
              }
              cursor
            }
            pageInfo {
              hasNextPage
              endCursor
            }
          }
          changes(first: 1000) {
            edges {
              node {
                id
                when
              }
            }
          }
          ...Core_viewer

        }
       """)
  private[this] object viewer extends js.Object

  class Backend(val $ : BackendScope[RouterCtl[Page], Unit]) extends RelayBackend[BaseViewerFrag] {

    val hdr = Menu(mode = "horizontal", id = "nav")(Menu.Item(key = "home")("Home"))

    def render(ctl: RouterCtl[Page]) = {

      Core.Container
        .rprops(relayProps)(Core.Props(false, ctl, Routes.Home))(
          Row()(
            Col((new Col.Opt {
              override val sm = 24
              override val md = 18
            })(^.marginBottom := "20px", ^.textAlign := "center"))(
              <.h1(s"Welcome ${relayProps.viewer.user.map(_.user.firstName)}!"),
              <.p(s"You insured person, you."))),
          AnnotatedRow.C(
            AnnotatedRow.Props(b => PolicyList(relayProps.viewer.policies.edges.map(_.node), b),
                               Some(<.div("""
                           |Get a quick glance at your policies, you can click on the button to edit them. Keep
                           | in mind that all your changes get applied instantly, so no need to call or talk to a human
                           | to get it done!  However, if you would like to talk to a human, use the button in the corner.
                """.stripMargin)))),
          AnnotatedRow.C(
            AnnotatedRow.Props(
              b => HomeChangeList.C(HomeChangeList.Props(relayProps.viewer.changes.edges.map(_.node), b)),
              Some(<.div(
                "Some changes require approval before going into effect.  This is meant to illuminate those pending changes.")))))
    }
  }

  val C = ScalaComponent
    .builder[RouterCtl[Page]]("Home")
    .stateless
    .renderBackend[Backend]
    .buildRelay[BaseViewerFrag]

  val Container = FragmentContainer.buildRelay(C, "viewer" -> Home_viewer)

  override def toString = "[Home]"
}
