package web.views

import ant.cps._
import japgolly.scalajs.react._
import japgolly.scalajs.react.extra.router.RouterCtl
import japgolly.scalajs.react.vdom.html_<^._
import web.routes.Routes.Page
import web.base.all._
import web.routes.Routes

import scala.scalajs.js

object Lander {

  object styles {

    val Left = new Col.Opt {
      override val xs = new Size { override val offset = 1 }
      override val sm = new Size { override val offset = 1 }
      override val md = new Size { override val offset = 1 }
      override val lg = new Size { override val offset = 2 }
      override val xl = new Size { override val offset = 2 }
    }

    val B = new Col.Opt {
      override val xs = new Size { override val offset = 1; override val span = 21 }
      override val sm = new Size { override val offset = 1; override val span = 21 }
      override val md = new Size { override val offset = 1; override val span = 6 }
      override val lg = new Size { override val offset = 2; override val span = 6 }
      override val xl = new Size { override val offset = 2; override val span = 4 }
    }
  }

  case class Props(ctl: RouterCtl[Page])
  class Backend(val $ : BackendScope[Props, Unit]) {

    def quoteClick(re: ReactEvent) =
      re.preventDefaultCB.flatMap { _ =>
        $.props.flatMap(_.ctl.set(Routes.QuotePage(None)))
      } >> Callback.log("quoteClick")

    def render(p: Props) = {
      //
      <.div(^.minHeight := "100vh", ^.className := "c-spartan-bg")(
        <.div(^.className := clnLo("header"))(Menu(mode = "horizontal", id = "nav", onSelect = {
          _: Menu.SelectMenuCallback =>
            p.ctl.set(Routes.Home).runNow()
        })(Menu.Item(key = "home")("Home"))),
        <.div(^.className := "c-spartan-container")(
          Row()(Col(styles.Left)(<.div(^.className := "c-spartan-message")("What would you like to do today?"))),
          Row()(
            Col(styles.B)(Button((new Button.Opt {
              override val size = "large"
            })(^.onClick ==> p.ctl.setEH(Routes.Login)))(<.span("Login"), Icon("user"))),
            Col(styles.B)(Button((new Button.Opt {
              override val size = "large"
            })(^.onClick ==> quoteClick))(<.span("Get Insured!"), Icon("check"))))))
    }
  }

  val C = ScalaComponent.builder[Props]("Lander").stateless.renderBackend[Backend].build
}
