package web.views

import ant.cps.Form.Item
import ant.cps._
import dispalt.relay.gql
import japgolly.scalajs.react._
import japgolly.scalajs.react.extra.router.RouterCtl
import japgolly.scalajs.react.vdom.html_<^._
import monix.execution.Ack
import monix.reactive.OverflowStrategy
import org.scalajs.dom
import relay.components._
import relay.generated.Settings_viewer
import relay.graphql.TaggedNode
import relay.runtime.RecordSourceSelectorProxy
import relay.runtime.subscription.RequestRelaySubscription
import web.base.all._
import web.base.data.BaseViewerFrag
import web.cps.NameSettings
import web.routes.Routes
import web.routes.Routes.Page
import web.run.Env

import scala.scalajs.js

object Settings {

  //
  private val C = ScalaComponent
    .builder[(RouterCtl[Page])]("Settings")
    .stateless
    .render { p =>
      val rb = p.relayBackend[BaseViewerFrag]

      Core.Container
        .rprops(rb.relayProps)
        .apply(Core.Props(fluid = false, ctl = p.props, p = Routes.SettingsPage))(
          <.div(^.textAlign := "center", ^.marginBottom := "20px")(
            <.h1("Personal Information"),
            <.p("Keep your information up to date so we can accurately respond to a claim or question.")),
          Row(Row.Opt, ^.marginBottom := "20px")(
            Card(new Card.Opts {
              override val className = "card-thck"
              override val title     = "Name"
            })(NameSettings.Container.rprops(new NameSettings.HOCProps {
              val viewer = rb.relayProps.viewer
            })()
//              ""
            )),
          Row()(Card(new Card.Opts {
            override val className = "card-thck"
            override val title     = "Locations"
          })()))
    }
    .buildRelay[BaseViewerFrag]

  @gql("""
      fragment Settings_viewer on Viewer {
        changes(
          after: $after,
          first: $first
        ) @connection(key: "NameSettings_changes") {
          edges {
            node {
              when, before, after
            }
            cursor
          }
          pageInfo {
            hasNextPage, endCursor
          }
        }
        ...Core_viewer
        ...NameSettings_viewer
      }
    """)
  object settingsFrag extends TaggedNode

  val Container = FragmentContainer.buildRelay(C, "viewer" -> Settings_viewer)

}
